package com.example.demo.Controllers;

import com.example.demo.Models.Baker;
import com.example.demo.Repositories.BakerRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
public class BakerController {

    private BakerRepository bakerRepository;

    @Autowired
    public BakerController(BakerRepository bakerRepository){
        this.bakerRepository = bakerRepository;
    }

    @RequestMapping(value="/bakers", method= RequestMethod.GET)
    public ResponseEntity<Iterable<Baker>> index() {
        return new ResponseEntity<>(this.bakerRepository.findAll(), HttpStatus.OK);
    }

    @RequestMapping(value="/bakers/{id}", method= RequestMethod.GET)
    public ResponseEntity<Baker> show(@PathVariable Long id) {
        return new ResponseEntity<>(this.bakerRepository.findById(id).get(), HttpStatus.OK);
    }

    @RequestMapping(value="/bakers", method= RequestMethod.POST)
    public ResponseEntity<Baker> create(@RequestBody Baker baker) {
        return new ResponseEntity<>(this.bakerRepository.save(baker), HttpStatus.CREATED);
    }

    @RequestMapping(value="/bakers/{id}", method= RequestMethod.PUT)
    public ResponseEntity<Baker> update(@PathVariable Long id, @RequestBody Baker baker) {
        Baker foundBaker = bakerRepository.findById(id).get();

        foundBaker.setName(baker.getName());
        foundBaker.setSpecialty(baker.getSpecialty());

        return new ResponseEntity<>(this.bakerRepository.save(foundBaker), HttpStatus.OK);
    }

    @RequestMapping(value="/bakers/{id}", method= RequestMethod.DELETE)
    public ResponseEntity<Boolean> destroy(@PathVariable Long id) {
        this.bakerRepository.deleteById(id);
        return new ResponseEntity<>(true, HttpStatus.OK);
    }

}
